<?php


namespace Zeedhi\DataMining\Common\Service\PeriodMathExpression\Strategy;


class UnitFactory
{

    const OPERATIONS = array(
        '+',
        '-',
        '=',
    );

    const CLASS_UNIT = array(
        'D'=> 'Day',
        'W'=> 'Week',
        'M'=> 'Month',
        'Y'=> 'Year',
    );
    const METHOD_OPERATOR = array(
        '+'=> 'add',
        '-'=> 'sub',
        '='=> 'set',
    );
    const ADD = '+';
    const SUB = '-';
    const SET = '=';

    const DAY = 'D';
    const WEEK = 'W';
    const MONTH = 'M';
    const YEAR = 'Y';

    /**
     * @param $unit
     * @return UnitInterface
     * @throws \Exception
     */
    public static function factory($unit):UnitInterface
    {
        $strategy = null;
        $unit = strtoupper($unit);
        switch ($unit) {
            case self::DAY :
                $strategy = new Day();
                break;
            case self::WEEK :
                $strategy = new Week();
                break;
            case self::MONTH :
                $strategy = new Month();
                break;
            case self::YEAR :
                $strategy = new Year();
                break;
            default :
                throw new \Exception('Unit not found');
                break;
        }
        return $strategy;
    }
}